

//opem MP401
extern "C" HANDLE __declspec(dllimport)  __stdcall MP9401_OpenDevice(long dev_num);
//close device
extern "C" long __declspec(dllimport)  __stdcall MP9401_CloseDevice(HANDLE hDevice);


//*********************************************************************************
//eeprom
//max: read / write length 32 /times
//eeprom adr=0-8191  8K byte
extern "C" long __declspec(dllimport)  __stdcall MP9401_WriteEEPROM(HANDLE hDevice,long adr,long len,unsigned char *data);
extern "C" long __declspec(dllimport)  __stdcall MP9401_ReadEEPROM(HANDLE hDevice,long adr,long len,unsigned char *data);





//********************************************
//get board info
//model or type in *bStr
extern "C" long __declspec(dllimport)  __stdcall MP9401_Info(HANDLE hDevice,char *modle);


//**************************************************************************************
//return 1 : busy and data not ready / =0 data ok
//read ad data of 2ch
extern "C" long __declspec(dllimport)  __stdcall MP9401_ADREAD(HANDLE hDevice,long *data0, long *data1);

//start AD
extern "C" long __declspec(dllimport)  __stdcall MP9401_ADRUN(HANDLE hDevice);


//*****************************************************************
//set AD speed
//speed=0 low 10hz / =1 high 80hz
extern "C" long __declspec(dllimport)  __stdcall MP9401_SPEED(HANDLE hDevice,long speed);

//start cal ad
extern "C" long __declspec(dllimport)  __stdcall MP9401_CAL(HANDLE hDevice);
//poll cal end / return =0 end / =1 busy
extern "C" long __declspec(dllimport)  __stdcall MP9401_POLL(HANDLE hDevice);




//set dout
extern "C" long __declspec(dllimport)  __stdcall MP9401_DO(HANDLE hDevice,long dodata);
//read DI
extern "C" long __declspec(dllimport)  __stdcall MP9401_DI(HANDLE hDevice);





//**********************************************************************************
//read a byte from hardware
extern "C" long __declspec(dllimport)  __stdcall MP401_inb(HANDLE hdevice,int adr);
//read a word from hardware
//extern "C" long __declspec(dllimport)  __stdcall MP401_inw(HANDLE hdevice,int adr);
//write byte
extern "C" long __declspec(dllimport)  __stdcall MP401_outb(HANDLE hdevice,long adr,long data1);
//write word
//extern "C" long __declspec(dllimport)  __stdcall MP401_outw(HANDLE hdevice,long adr,long data1);


////////////////////////end
//cal ad
extern "C" long __declspec(dllimport)  __stdcall MP9401_CAL(HANDLE hDevice);
