// TEST9401Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TEST9401.h"
#include "TEST9401Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




//////////////////////////////////////////////////////////////////////////////
//added lib of MP401
#pragma comment(lib,"mp9401.lib")
#include "mp9401.h"

HANDLE hDevice=INVALID_HANDLE_VALUE;





/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
//	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTEST9401Dlg dialog

CTEST9401Dlg::CTEST9401Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTEST9401Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTEST9401Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTEST9401Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTEST9401Dlg)
	DDX_Control(pDX, IDC_LIST_SP, m_LISTSP);
	DDX_Control(pDX, IDC_BUTTON_AD, m_AD);
	DDX_Control(pDX, IDC_MLIST, m_MLIST);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTEST9401Dlg, CDialog)
	//{{AFX_MSG_MAP(CTEST9401Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_TEST, OnButtonTest)
	ON_BN_CLICKED(IDC_BUTTON_SPEED, OnButtonSpeed)
	ON_BN_CLICKED(IDC_BUTTON_END, OnButtonEnd)
	ON_BN_CLICKED(IDC_BUTTON_DIO, OnButtonDio)
	ON_BN_CLICKED(IDC_BUTTON_CAL, OnButtonCal)
	ON_BN_CLICKED(IDC_BUTTON_AD, OnButtonAd)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTEST9401Dlg message handlers

BOOL CTEST9401Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here


    //----------------------------------------------------------------------------
	//get my USB Device and data intial

	
	//ad is stop
	CTEST9401Dlg::adrun=FALSE;
	CTEST9401Dlg::adspeed=0;  //speed 10Hz start 


	//get device
	hDevice=MP9401_OpenDevice(0);

	
	if(hDevice==INVALID_HANDLE_VALUE)
	{
		//error open USB Deivce
		Beep(1000,300);
		
		AfxMessageBox("Error Open MP9401, Check Driver or USB Device");
		
	}
	else
	{

          m_MLIST.InsertString(-1,"Device MP9401 Open OK!");
		  Beep(300,50);


	}
    

    
	//dis speed
	m_LISTSP.InsertString(0,"10");



	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTEST9401Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTEST9401Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTEST9401Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTEST9401Dlg::OnButtonTest() 
{
	// TODO: Add your control notification handler code here
	m_MLIST.ResetContent();


	CString aa;

	aa.Format("Testing DIO...............................");
	m_MLIST.InsertString(-1,aa);

	int i,j;
    int k=0;

	for(i=0;i<7;i++)
	{

        //set out
		MP9401_DO(hDevice,i);

		j=MP9401_DI(hDevice);


        if(i!=j)
		{

           k++;
           aa.Format("Error! data=%XH    Read:%xH",i,j);
		   m_MLIST.InsertString(-1,aa);	


		}

    		aa.Format("+");
		    m_MLIST.InsertString(-1,aa);	
            

	}


	if(k==0)
	{
           aa.Format("Tesing OK!");
		   m_MLIST.InsertString(-1,aa);	


	}



	
}

void CTEST9401Dlg::OnButtonSpeed() 
{
	// TODO: Add your control notification handler code here
	m_LISTSP.ResetContent();

	if(CTEST9401Dlg::adspeed==0)
	{
		m_LISTSP.AddString("80");
        CTEST9401Dlg::adspeed=1;
	}
	else
	{
	    m_LISTSP.AddString("10");
        CTEST9401Dlg::adspeed=0;


	}


	//set speed
	MP9401_SPEED(hDevice,CTEST9401Dlg::adspeed);

	m_MLIST.InsertString(-1,"CAL.....");
	cal();
	m_MLIST.InsertString(-1,"CAL.....END");
}

void CTEST9401Dlg::OnButtonEnd() 
{
	// TODO: Add your control notification handler code here

	//close handle

	if(hDevice!=INVALID_HANDLE_VALUE)
		MP9401_CloseDevice(hDevice);

	//end
	exit(0);


	
}

void CTEST9401Dlg::OnButtonDio() 
{
	// TODO: Add your control notification handler code here


	m_MLIST.ResetContent();

   


	
}


//Cal AD
void CTEST9401Dlg::OnButtonCal() 
{
	// TODO: Add your control notification handler code here
	
	int sp=0;

	m_MLIST.ResetContent();
	

	if(CTEST9401Dlg::adspeed==0)
		sp=0;
	else
		sp=1;

	//set temp speed
	MP9401_SPEED(hDevice,sp);


	CString aa;
	
//	m_MLIST.ResetContent();

	aa.Format("Cal AD....... Waiting.......");
    m_MLIST.InsertString(-1,aa);
	m_MLIST.UpdateWindow(); 

    MP9401_CAL(hDevice);
	
    long j=cal();

	aa.Format("Cal END!  cnt=%d",j);
    m_MLIST.InsertString(-1,aa);


}

void CTEST9401Dlg::OnButtonAd() 
{
	// TODO: Add your control notification handler code here
	
    if(CTEST9401Dlg::adrun)
	{
        //true ad is run
		
		//stop AD
        CTEST9401Dlg::adrun=FALSE;
	   	m_AD.SetWindowText("AD RUN");

		KillTimer(1);


	}
	else
	{
        //start AD
        CTEST9401Dlg::adrun=TRUE;
        m_AD.SetWindowText("AD STOP");

        
		//set Speed
		MP9401_SPEED(hDevice,CTEST9401Dlg::adspeed);
		
		m_MLIST.InsertString(-1,"Waiting Cal.....");
        cal();

		////////////////////////////////////////////////////
		//start ad

        SetTimer(1,300,NULL);


	}



}



void CTEST9401Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);

    int i=0;

	long dd0=0;
	long dd1=0;
	double v0,v1;
    //dis data
	CString aa;
    
	m_MLIST.ResetContent();

	aa.Format("--------------------------------AD----------------------------");
	m_MLIST.InsertString(-1,aa);
    m_MLIST.InsertString(-1," ");


	
    //sam ad

	//run
	MP9401_ADRUN(hDevice);

	//if end
    do{

       i=MP9401_ADREAD(hDevice,&dd0,&dd1);

	}while(i!=0);

    //caculate voltage
	v0=(double)(dd0-0x800000)/(double)0x800000*1250.0;
    v1=(double)(dd1-0x800000)/(double)0x800000*1250.0;

    
    aa.Format("CH0 DATA:%10d   %10XH    V=%10.3fmV",dd0,dd0,v0);
	m_MLIST.InsertString(-1,aa);

    aa.Format("CH1 DATA:%10d   %10XH    V=%10.3fmV",dd1,dd1,v1);
	m_MLIST.InsertString(-1,aa);
    
	m_MLIST.InsertString(-1,"--------------------------------------------------------------");
    
	aa.Format("Speed data=%d",CTEST9401Dlg::adspeed);
	m_MLIST.InsertString(-1,aa);
    




}


//cal ad
long CTEST9401Dlg::cal()
{
	int i=0;
    int j=0;

	do{

    	
       i=MP9401_POLL(hDevice);
	   Sleep(10);
	   j++;

	}while(i!=0);

	return j;
}
