// ts401.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <windows.h>


//////////////////////////////////////////////////////////////////////////////
//added lib of MP401
#pragma comment(lib,"mp9401.lib")

#include "mp9401.h"



HANDLE hDevice=INVALID_HANDLE_VALUE;


int main(int argc, char* argv[])
{
	
	int i=0;
	int j=0;
	char a[80];

	long caldata=0; //temp buffer for cal data

		//open device
	printf("Open Device Mp9401........");

	hDevice=MP9401_OpenDevice(0);

	
	if(hDevice==INVALID_HANDLE_VALUE)
	{
		printf("error open USB Deivce\n");
		Beep(1000,300);
		getch();
		exit(0);
	}
    else
	{  
		printf("Device Num:%d\n",hDevice);
	}
	
   

  	

    //get info of Mp401
    i=MP9401_Info(hDevice,a);
	printf("Mp401's Board Design Infomation:%s\n",a);


   for(i=0;i<8;i++)
   {
	   MP9401_DO(hDevice,i);
	   //di
	   printf("Set Do=%d   read DI=%d\n",i,MP9401_DI(hDevice));
   }


	getch();



	printf("Testing AD..............................................\n");


//cal

	//set speed =0  low sp
	
	MP9401_SPEED(hDevice,1);
    
		
	
	MP9401_CAL(hDevice);

	int cc=0;




	

	//if cal end
    do{

	  i=MP9401_POLL(hDevice);
  	  cc++;
	  Sleep(10);

	}while(i!=0);

	

      i=MP401_inb(hDevice,0);
      printf("%5x",i );
	  printf("...................................cal ok............................\n cnt=%d\n",cc);





	  getch();



	  printf("\n");

     long data0,data1;

     

	 do{

		 MP9401_ADRUN(hDevice);
		 
		 do{
			 i=MP9401_ADREAD(hDevice,&data0,&data1);
			 //printf("%5x",i);

		 }while(i!=0);

		 //printf("\n");

          //MP401_outb(hDevice,1,0);

		  //if end
		  //do{
            //   j=MP401_inb(hDevice,0) & 0x3;

		  //}while(j!=0);

          //data0=MP401_inb(hDevice,2)  | (MP401_inb(hDevice,3)<<8)  | (MP401_inb(hDevice,4)<<16);
		  //data1=MP401_inb(hDevice,8)  | (MP401_inb(hDevice,9)<<8)  | (MP401_inb(hDevice,0xa)<<16);

		  printf("AD Data:  %x    %x\n",data0,data1);



	 }while(!kbhit());





////////////////////////////////////////////////////////////////////////////////

	getch();
	MP9401_CloseDevice(hDevice);

  return 0;
}